﻿using System.Collections.Generic;
using System.Linq;
using System.Windows.Browser;
using FDOT.GIS.Client.Domain;

namespace FDOT.GIS.Client.Components.Commands
{
    [ScriptableType]
    public class FeatureData
    {
        public Dictionary<string, string> Data { get; set; }
        public DataContracts.Geometry Geometry { get; set; }

        public string[] Keys
        {
            get { return Data.Keys.ToArray(); }
        }

        public FeatureData(Feature feature)
        {
            Data = new Dictionary<string, string>();
            foreach (var key in feature.FeatureType.Attributes)
                Data.Add(key.Name, feature[key].ToString());

            Geometry = feature.Geometry;
        }
    }
}