﻿using System;
using System.Collections.Generic;
using Caliburn.Micro;
using FDOT.GIS.Client.Commands;
using FDOT.GIS.Client.Domain;

namespace FDOT.GIS.Client.Components.Commands
{
    public class Identify : ResultBase
    {
        private readonly DataContracts.Geometry _geometry;
        private readonly IEnumerable<FeatureType> _featureTypes;

        public Identify(DataContracts.Geometry geometry, IEnumerable<FeatureType> featureTypes)
        {
            _geometry = geometry;
            _featureTypes = featureTypes;
        }

        public IDictionary<FeatureType, ICollection<Feature>> Result { get; internal set; }

        public override void Execute(ActionExecutionContext context)
        {
            try
            {
                VirtualApplicationManager.Current.QueryManager.ExecuteIdentify(_geometry, r =>
                {
                    Log.Info("ExecuteIdentify complete, returned [{0}] results.", r.Count);
                    Result = r;
                    Success();
                }, _featureTypes);
            }
            catch (Exception ex)
            {
                Log.Error(ex);
                Failure(ex);
            }
        }





    }
}
