﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Browser;
using FDOT.GIS.Client.Domain;

namespace FDOT.GIS.Client.Components.Commands
{
    [ScriptableType]
    public class QueryCompletedEventArgs : EventArgs
    {
        private readonly FeatureData[] _results;

        public QueryCompletedEventArgs(object clientData, IEnumerable<Feature> results)
        {
            ClientData = clientData;
            _results = results.Select(x => new FeatureData(x)).ToArray(); 
        }

        public object ClientData { get; set; }

        public FeatureData[] Results
        {
            get { return _results; }
        }
    }
}