﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Windows.Data;
using FDOT.GIS.Client.Domain;
using FDOT.GIS.DataContracts;

namespace FDOT.GIS.Client.Components.Converters
{

    public class AttributeDescriptionToOperatorsConverter : IValueConverter
    {
        #region IValueConverter Members

        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            var types = new List<ComparisonType>();
            if (value == null)
            { return types; }


            Type type = ((AttributeDescription)value).Type;
            types.Add(ComparisonType.Equals);
            types.Add(ComparisonType.NotEqual);

            if (type == typeof(string))
            {
                types.Add(ComparisonType.Contains);
                types.Add(ComparisonType.BeginsWith);
                types.Add(ComparisonType.EndsWith);
            }
            else
            {
                types.Add(ComparisonType.GreaterThan);
                types.Add(ComparisonType.GreaterThanOrEqual);
                types.Add(ComparisonType.LessThan);
                types.Add(ComparisonType.LessThanOrEqual);
            }
            return types;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }

        #endregion
    }
}
