﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using FDOT.GIS.Client.Domain;

namespace FDOT.GIS.Client.Components.Converters
{
    public class IdentifyResultsToTabItemsConvertor : System.Windows.Data.IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            var sourceData = value as IEnumerable<Feature>;
            if (sourceData == null) return null;
            
            List<KeyValuePair<string, List<Feature>>> data = sourceData.GroupBy(d => d.FeatureType.Name)
                .Select(grp => new KeyValuePair<string, List<Feature>> (grp.Key, grp.ToList())).ToList();

            return data;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

    public class FindOperationResultNameValueConvertor : System.Windows.Data.IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            var sourceData = value as Feature;
            if (sourceData == null) return null;

            return sourceData.ToString();
            //return string.IsNullOrEmpty(sourceData) ? sourceData.Attributes.First().Value : sourceData.Attributes[sourceData.DisplayName];
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }

    }

    //public class MyClass
    //{
    //    public string LayerName { get; set; }
    //    public IEnumerable<Feature> Results { get; set; }
    //}
}
