﻿using System;
using System.Globalization;
using System.Windows.Data;
using FDOT.GIS.DataContracts.Enums;

namespace FDOT.GIS.Client.Components.Converters
{
    public class StringToSpatialRelationshipConverter : IValueConverter
    {
        #region IValueConverter Members

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return value;
        }

        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if (value == null)
                return null;

            var val = (QuerySpatialRelationships) value;

            switch(val)
            {
                case QuerySpatialRelationships.Intersects:
                    return "The features overlap the selected geometry";
                case QuerySpatialRelationships.Contains:
                    return "The features are contained by the selected geometry";
                case QuerySpatialRelationships.Crosses:
                    return "The featues intersect the selected geometry";
                case QuerySpatialRelationships.EnvelopeIntersects:
                    break;
                case QuerySpatialRelationships.Overlaps:
                    return "The feature overlaps the selected geometry";
                case QuerySpatialRelationships.Touches:
                    return "The features boundaries touches the seleted geometry's boundaries";
                case QuerySpatialRelationships.Within:
                    return "The selected geometry is contained within the features";
                default:
                    throw new ArgumentOutOfRangeException(val.ToString());
            }

            return value;
        }

        #endregion
    }
}