﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Windows.Data;
using FDOT.GIS.Client.Domain;
using FDOT.GIS.Client.Domain.Gis;

namespace FDOT.GIS.Client.Components.Converters
{
    public class SublayerConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if(value == null) return null;

            foreach (var layer in (IEnumerable<DisplayLayer>)value)
            {
                if (layer.SubLayers != null && layer.SubLayers.Count > 0)
                {
                    foreach (var mapSvs in VirtualApplicationManager.Current.Configuration.MapServices)
                    {
                        if (mapSvs.Url == layer.ParentMapService.Url &&
                            mapSvs.CollapsedGroupIds != null &&
                            mapSvs.CollapsedGroupIds.Contains(layer.Id))
                        {
                            layer.SubLayers.Clear();
                        }
                    }
                }
            }
            return value;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

}
