﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using FDOT.GIS.Client.Domain;

namespace FDOT.GIS.Client.Components.StartupActions
{
    [Export(typeof (IStartupAction))]
    [PartCreationPolicy(CreationPolicy.NonShared)]
    public class OpenComponentStartupAction:IStartupAction
    {
        private string _componentToStart;
        public bool IsInitialized { get; private set; }

        public string StartupActionText
        {
            get { return "Opening Components"; }
        }

        public void Initialize(IDictionary<string, string> customSettings)
        {
            if(!customSettings.ContainsKey("ComponentName"))
                return;

            _componentToStart = customSettings["ComponentName"];
            IsInitialized = true;
        }

        public void ExecuteStartupAction()
        {
            LayoutManager.Instance.ShowComponentByName(_componentToStart);
            Complete(this, null);
        }

        public event EventHandler Complete;
    }
}
