﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using FDOT.GIS.Client.Commands;
using FDOT.GIS.Client.Domain;

namespace FDOT.GIS.Client.Components
{
    [Export]
    [PartCreationPolicy(CreationPolicy.NonShared)]
    [DisplayName("Command Window")]
    public class CommandProcessor : ComponentBase
    {

        private string[] _commandLine;

        [DisplayName("Command:")]
        public string CommandKey { get; set; }

        [DisplayName("Hint:")]
        public string Hint { get { return "zc {'value':'Leon','highlight':'true'} (te to throw an exception)"; } }

        protected override void OnInitialize(IDictionary<string, string> customSettings)
        { }

        public void ExecuteCommand()
        {
            if (CommandKey == "te")
            {
                throw new Exception(ToString() + " has failed miserably");
            }

            _commandLine = CommandKey.Split(' ');
            string key = _commandLine[0];

            string argument = _commandLine[1];
            IScriptableCommand command = VirtualApplicationManager.Current.GetCommandByKey(key);
            if (command != null)
                command.Execute(argument);
            else
                LayoutManager.Instance.ShowMessage("Command " + key + " is not available");
        }

        protected override string IconResourceUri
        {
            get { return "Assets/Images/help.png"; }
        }

        protected override void OnExecute()
        {
            CreateChildWindow(this);
        }

        protected override void OnError(ErrorEventArgs errorEventArgs)
        {

        }
    }

    //[Export(typeof(IComponentBase))]
    //[PartCreationPolicy(CreationPolicy.NonShared)]
    //[DisplayName("Zoom Tool")]
    //public class ZoomToolDto : ComponentBase
    //{
    //    [Dropdown("ZoomTypes")]
    //    [DisplayName("Zoom To")]
    //    public ZoomTypes ZoomType { get; set; }

    //    public string Id
    //    {
    //        get { return _parameters.Value; }
    //        set { _parameters.Value = value; }
    //    }

    //    public bool Highlight
    //    {
    //        get { return _parameters.Highlight; }
    //        set { _parameters.Highlight = value; }
    //    }

    //    private readonly ZoomCommandParameters _parameters = new ZoomCommandParameters();

    //    public void ExecuteZoom()
    //    {
    //        var zoomCommand = GetZoomCommand(ZoomType);
    //        zoomCommand.Execute(_parameters);
    //    }

    //    [Hidden]
    //    public override System.Windows.DependencyObject HelpView
    //    {
    //        get
    //        {
    //            var help = new ZoomToolHelpView();
    //            View.SetModel(help, new ZoomToolHelpViewModel());
    //            return help;
    //        }
    //    }

    //    private static ZoomCommand GetZoomCommand(ZoomTypes type)
    //    {
    //        switch (type)
    //        {
    //            case ZoomTypes.County:
    //                return (ZoomCommand)VirtualApplicationManager.Current.ScriptableCommands.SingleOrDefault(c => (c as ZoomToCountyInitialCommand) != null);
    //            case ZoomTypes.District:
    //                return (ZoomCommand)VirtualApplicationManager.Current.ScriptableCommands.SingleOrDefault(c => (c as ZoomToDistrictInitialCommand) != null);
    //            case ZoomTypes.Roadway:
    //                return (ZoomCommand)VirtualApplicationManager.Current.ScriptableCommands.SingleOrDefault(c => (c as ZoomToRoadwayInitialCommand) != null);
    //            default:
    //                throw new ArgumentOutOfRangeException("type");
    //        }
    //    }

    //    public enum ZoomTypes
    //    {
    //        County,
    //        District,
    //        Roadway
    //    }

    //    protected override void OnInitialize(IDictionary<string, string> customSettings)
    //    { }

    //    protected override string GetIconResourceUri()
    //    {
    //        return "Assets/Images/jump_to.png";
    //    }

    //    protected override void OnExecute()
    //    {
    //        var childWindow = CreateChildWindow(this);
    //        childWindow.Closed += OnChildWindowClose;
    //    }

    //    private void OnChildWindowClose(object sender, EventArgs e)
    //    {
    //        _parameters.Highlight = false;
    //    }

    //    protected override void OnError(ErrorEventArgs errorEventArgs)
    //    {

    //    }

    //    //[Hidden]
    //    //public override System.Windows.DependencyObject HelpView
    //    //{
    //    //    get { return new ZoomToolHelp(); }           
    //    //}

    //}

    //public class IdentifyComponent : IComponentBase
    //{       
    //    public void Initialize()
    //    {
    //        throw new NotImplementedException();
    //    }

    //    public void Execute()
    //    {
    //        var layerIds = MapHandler.Layers.SelectMany(l => l.Layers.Select(layer=> layer.id));
    //        var queryService = ServiceClients.GetQueryServiceClient();
    //        var options = new IdentifyOptions {LayerOptions = new LayersOptions {IdentifyLayerLevel = IdentifyLayerLevels.Visible, Layers = new ObservableCollection<Layer>()}};
    //    }

    //    public void OnError(ErrorEventArgs errorEventArgs)
    //    {
    //        throw new NotImplementedException();
    //    }
    //}
}
