﻿using System;
using System.Collections.Generic;
using FDOT.GIS.Client.Domain;

namespace FDOT.GIS.Client.Components.ViewModels.Help
{
    public class QueryToolHelpViewModel
    {
        public Uri LayerImage
        {
            get { return GetImage("QueryLayerHelp.png"); }
        }

        public Uri TextCriteriaImage
        {
            get { return GetImage("QueryTextCriteriaHelp.png"); }
        }

        public Uri SpatialCriteriaImage
        {
            get { return GetImage("QuerySpatialCriteriaHelp.png"); }
        }

        public Uri QueryWindowImage
        {
            get { return GetImage("QueryWindowHelp.png"); }
        }

        public Uri SettingsIconImage
        {
            get { return GetImage("SettingsIconHelp.png"); }
        }

        public Uri SaveQueryImage
        {
            get { return GetImage("SaveQueryHelp.png"); }
        }

        public Uri SaveQueryWindowImage
        {
            get { return GetImage("SaveQueryWindowHelp.png"); }
        }

        public Uri SaveQueryViewImage
        {
            get { return GetImage("SavedQueryViewHelp.png"); }
        }

        public Uri RecentQueryWindowImage
        {
            get { return GetImage("RecentQueryWindowHelp.png"); }
        }

        public Uri AddCriteriaButtonImage
        {
            get { return GetImage("AddCriteriaButtonHelp.png"); }
        }

        public Uri AddCriteriaImage
        {
            get { return GetImage("AddCriteriaHelp.png"); }
        }

        public Uri SelectGeometryImage
        {
            get { return GetImage("SelectGeometryHelp.png"); }
        }

        public Uri SelectGeometryInstructionsImage
        {
            get { return GetImage("SelectGeometryInstructionsHelp.png"); }
        }

        public Uri GeometryOptionsButtonImage
        {
            get { return GetImage("GeometryOptionsButtonHelp.png"); }
        }

        public Uri SpatialOptionsImage
        {
            get { return GetImage("SpatialOptionsHelp.png"); }
        }

        public IList<SpatialRelationshipHelp> SpatialRelationsHelp
        {
            get
            {
                return new List<SpatialRelationshipHelp>
                           {
                               new SpatialRelationshipHelp
                                   {
                                       Name = "Intersects",
                                       Description =
                                           "When a any part of the comparison geometry touches the boundaries or interior of the base geometry.",
                                       LineLineImage = GetImage("IntersectsLineLine.Png"),
                                       LinePolygonImage = GetImage("IntersectsLinePolygon.Png"),
                                       PolygonLineImage = GetImage("IntersectsPolygonLine.Png"),
                                       PolygonPolygonImage = GetImage("IntersectsPolygonPolygon.Png")
                                   },
                               new SpatialRelationshipHelp
                                   {
                                       Name = "Contains",
                                       Description = "If the comparison geometry is completely inside base geometry.",
                                       LineLineImage = GetImage("ContainsLineLine.Png"),
                                       LinePolygonImage = GetImage("ContainsLinePolygon.Png"),
                                       PolygonLineImage = GetImage("ContainsPolygonLine.Png"),
                                       PolygonPolygonImage = GetImage("ContainsPolygonPolygon.Png")
                                   }
                               ,
                               new SpatialRelationshipHelp
                                   {
                                       Name = "Crosses",
                                       Description =
                                           "Two polylines cross if they share only points in common, at least one of which is not an endpoint.  A polyline and an polygon cross if they share a polyline in common on the interior of the polygon which is not equivalent to the entire polyline.",
                                       LineLineImage = GetImage("CrossesLineLine.Png"),
                                       LinePolygonImage = GetImage("CrossesLinePolygon.Png"),
                                       PolygonLineImage = GetImage("CrossesPolygonLine.Png"),
                                       PolygonPolygonText = "Crosses is not possible"
                                   }
                               ,
                               new SpatialRelationshipHelp
                                   {
                                       Name = "Envelope Intersects",
                                       Description =
                                           "Compares if the envelope of base geometry intersects envelope of the comparsion geometry.",
                                       LineLineImage = GetImage("EnvelopeIntersectsLineLine.Png"),
                                       LinePolygonImage = GetImage("EnvelopeIntersectsLinePolygon.Png"),
                                       PolygonLineImage = GetImage("EnvelopeIntersectsPolygonLine.Png"),
                                       PolygonPolygonImage = GetImage("EnvelopeIntersectsPolygonPolygon.Png")
                                   }
                               ,
                               new SpatialRelationshipHelp
                                   {
                                       Name = "Overlaps",
                                       Description = "If the two geometries share a common sub-line or common sub-area.",
                                       LineLineImage = GetImage("OverlapsLineLine.Png"),
                                       LinePolygonText = "Overlap is not possible",
                                       PolygonLineText = "Overlap is not possible",
                                       PolygonPolygonImage = GetImage("OverlapsPolygonPolygon.Png")
                                   }
                               ,
                               new SpatialRelationshipHelp
                                   {
                                       Name = "Touches",
                                       Description =
                                           "Two geometries are said to touch when the intersection of the geometries is non-empty, but the intersection of their interiors is empty.  This evaluates if the touch occurs along a boundary (not a point).",
                                       LineLineImage = GetImage("TouchesLineLine.Png"),
                                       LinePolygonImage = GetImage("TouchesLinePolygon.Png"),
                                       PolygonLineImage = GetImage("TouchesPolygonLine.Png"),
                                       PolygonPolygonImage = GetImage("TouchesPolygonPolygon.Png")
                                   }
                               ,
                               new SpatialRelationshipHelp
                                   {
                                       Name = "Within",
                                       Description =
                                           "If the Base Geometry i s completely inside the comparison geometry.",
                                       LineLineImage = GetImage("WithinLineLine.Png"),
                                       LinePolygonImage = GetImage("WithinLinePolygon.Png"),
                                       PolygonLineImage = GetImage("WithinPolygonLine.Png"),
                                       PolygonPolygonImage = GetImage("WithinPolygonPolygon.Png")
                                   }
                           };
            }
        }

        private static Uri GetImage(string imageName)
        {
            return new Uri(VirtualApplicationManager.HostSiteUrl + "Images/{0}".FormatWith(imageName));
        }
    }
}