﻿using System.Collections.ObjectModel;
using System.ComponentModel.Composition;
using System.Linq;
using ESRI.ArcGIS.Client;
using FDOT.GIS.Client.Components.Views.Printing;
using FDOT.GIS.Client.Domain;
using FDOT.GIS.Client.Domain.Gis;

namespace FDOT.GIS.Client.Components.ViewModels.Printing
{
    [Export]
    [PartCreationPolicy(CreationPolicy.Shared)]
    public class PrintPreviewViewModel : ComponentBase
    {
        public byte[] Image { get; set; }
        public bool IsBusy { get; set; }

        public Map Map
        {
            get { return MapHandler.CurrentMap; }
        }

        public string Title { get; set; }

        public string LogoImageUrl
        {
            get { return VirtualApplicationManager.Current.Configuration.LogoImage; }
        }

        protected PrintPreviewView View { get; set; }

        public ReadOnlyObservableCollection<MapService> DynamicMapServices
        {
            get
            {
                return new ReadOnlyObservableCollection<MapService>(new ObservableCollection<MapService>(MapHandler.DynamicLayers.OfType<MapService>().Where(l => l.IsViewable)));
            }
        }

        protected override void OnExecute()
        {
            //Image = MapHandler.GetMapPng();
            var view = new PrintPreviewView();

            Caliburn.Micro.View.SetModel(view, this);
            var dialog=LayoutManager.Instance.ShowPanel(view,
                                             new DialogServiceArgs
                                                 {
                                                     Title = "Print Preview",
                                                     HasSettingsButton = false
                                                 });

            View = view;
        }

        protected override string GetIconResourceUri()
        {
            return "Assets/Images/print.png";
        }

        //public void Print()
        //{
        //    View.mapPrinter.Title = Title;
        //    View.mapPrinter.PrintCommand.Execute(new List<int> {1});
        //}
    }
}