﻿using FDOT.GIS.Client.Domain;
using FDOT.GIS.Client.Domain.Persistence;
using FDOT.GIS.Client.ViewModels;

namespace FDOT.GIS.Client.Components.ViewModels.QueryTool
{
    [DisplayName("Query Settings")]
    public class QuerySettingsViewModel : SettingsViewModel
    {
        private static QuerySettingsViewModel _viewModel = new QuerySettingsViewModel();

        private QuerySettingsViewModel()
        {
            DialogServiceArgs.Id = "querysettings";
            DialogServiceArgs.Title = "Query Settings";
        }

        [Hidden]
        public static QuerySettingsViewModel Instance
        {
            get { return _viewModel; }
        }


        [SwitchButton]
        [DisplayName("Recent Query History")]
        [ToolTipText("Enables a listing of recent queries. Note: The history is temporary, so please use the Save feature for long-term storage of queries.")]
        public bool PersistRecentItems
        {
            get { return StateManager.DoPersistRecentItems; }
            set 
            { 
                StateManager.DoPersistRecentItems = value;
                NotifyOfPropertyChange(() => PersistRecentItems);
            }
        }


        [SwitchButton]
        [DisplayName("Save Queries")]
        [ToolTipText("Allows queries to be saved and restored.")]
        public bool PersistRecentQueries
        {
            get { return StateManager.DoPersistRecentQueries; }
            set 
            { 
                StateManager.DoPersistRecentQueries = value;
                NotifyOfPropertyChange(() => PersistRecentQueries);
            }
        }

        [SwitchButton]
        [ToolTipText("Allows queries to be saved and restored.")]
        public bool LimitQueriesToActiveLayers
        {
            get { return StateManager.LimitQueriesToActiveLayers; }
            set
            {
                StateManager.LimitQueriesToActiveLayers = value;
                NotifyOfPropertyChange(() => LimitQueriesToActiveLayers);
            }
        }
    }
}
