﻿using System.Collections.Generic;
using System.Collections.ObjectModel;
using Caliburn.Micro;
using FDOT.GIS.Client.Domain;
using FDOT.GIS.Client.Domain.Persistence;

namespace FDOT.GIS.Client.Components.ViewModels.QueryTool
{
    public class SavedQueryViewModel:Screen
    {
        public ObservableCollection<KeyValuePair<string, QueryParameters>> SavedQueries
        {
            get { return new ObservableCollection<KeyValuePair<string, QueryParameters>>(StateManager.SavedQueries); }
        }

        private KeyValuePair<string, QueryParameters> _selectedQuery;

        public KeyValuePair<string, QueryParameters> SelectedQuery
        {
            get { return _selectedQuery; }
            set { 
                _selectedQuery = value;
                ((QueryViewModel)Parent).CriteriaViewModel.LoadSpatialQueryOptions(value.Value);
            }
        }

        public void DeleteRow(KeyValuePair<string, QueryParameters> savedQuery)
        {
            StateManager.RemoveSavedQuery(savedQuery.Key);
            SavedQueries.Remove(savedQuery);
            NotifyOfPropertyChange(()=>SavedQueries);
        }

        public void DeleteAll()
        {
            StateManager.ClearSavedQueries();
            SavedQueries.Clear();
            NotifyOfPropertyChange(() => SavedQueries);
        }
    }
}
