﻿using System.Windows;
using System.Windows.Controls;
using Caliburn.Micro;
using FDOT.GIS.Client.Components.ViewModels;
using FDOT.GIS.Client.ViewModels;

namespace FDOT.GIS.Client.Components.Views
{
    public partial class IdentifyResultAttributesView : UserControl
    {
        private readonly IdentifyResultAttributesViewModel _viewModel;

        public IdentifyResultAttributesView()
        {
            InitializeComponent();

            // bind to the view model
            _viewModel = new IdentifyResultAttributesViewModel(this);
            ViewModelBinder.Bind(_viewModel, this, null);
        }

        public void SetDialog(GenericDialogViewModel dialogViewModel)
        {
            _viewModel.Dialog = dialogViewModel;
        }
        // this isn't ideal, but the context menu click handlers just aren't getting wired via Caliburn
        public void SendToResultsView(object sender, RoutedEventArgs e)
        {
            _viewModel.SendToResultsView(sender, e);
        }

        private void Layers_Unloaded(object sender, RoutedEventArgs e)
        {
            ((ItemsControl)(sender)).ItemsSource = null;
            ((ItemsControl)(sender)).DataContext = null;
            ((ItemsControl)(sender)).ItemsPanel = null;
            ((ItemsControl)(sender)).ItemTemplate = null;
        }

        private void AttributesGrid_Unloaded(object sender, RoutedEventArgs e)
        {
            ((DataGrid)sender).ItemsSource = null;
            ((DataGrid)sender).DataContext = null;
        }

        private void LayoutRoot_Unloaded(object sender, RoutedEventArgs e)
        {
            ((Grid) sender).DataContext = null;
            ((Grid) sender).Children.Clear();
        }
    }
}
