﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using ESRI.ArcGIS.Client;
using FDOT.GIS.Client.Domain.Gis;
using FDOT.GIS.Client.Printing;

namespace FDOT.GIS.Client.Components.Views.Printing
{
    public partial class PrintPreviewView : UserControl
    {
        public PrintPreviewView()
        {
            InitializeComponent();
        }

        private void comboPrintStyle_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            var combo = sender as ComboBox;

            string styleName = null;
            Style style = null;

            if (combo != null)
                styleName = (string)combo.SelectedItem;

            if (!string.IsNullOrEmpty(styleName))
                style = Resources[styleName] as Style;

            if (mapPrinter != null)
                mapPrinter.Style = style;
        }

        //private void Map_Loaded(object sender, RoutedEventArgs e)
        //{

        //}

        private void Overview_Map_Loaded(object sender, RoutedEventArgs e)
        {
            var map = sender as Map;
//            var layersToRemove = map.Layers.Where(l => l is GraphicsLayer && !(l is PrintOverviewLayer)).ToList();
            var layersToRemove = map.Layers.Where(l => !(l is PrintOverviewLayer)).ToList();
            layersToRemove.ForEach(l=>map.Layers.Remove(l));

            map.Layers.Insert(0, MapHandler.CurrentOverviewMap.Layer.Clone());
        }
    }
}
