﻿using System;
using System.Windows;
using System.Windows.Controls;
using FDOT.GIS.Client.Components.ViewModels.QueryTool;

namespace FDOT.GIS.Client.Components.Views.QueryTool
{
	public partial class QueryView : UserControl
	{
		public QueryView()
		{
			// Required to initialize variables
			InitializeComponent();
            this.Loaded += OnLoad;
		}

        private void OnLoad(object sender, RoutedEventArgs e)
        {
            var viewmodel = DataContext as QueryViewModel;
            if (viewmodel == null) return;

            foreach (HyperlinkButton hlb in HyperlinkMenu.Children)
            {
                if (viewmodel.QuerySection.Equals(hlb.Content.ToString(), StringComparison.OrdinalIgnoreCase))
                { VisualStateManager.GoToState(hlb, "ActiveLink", true); }
                else
                { VisualStateManager.GoToState(hlb, "InactiveLink", true); }
            }
        }

        private void HyperlinkButtonClick(object sender, RoutedEventArgs e)
        {
            foreach (HyperlinkButton hlb in HyperlinkMenu.Children)
            {
                if (ReferenceEquals(hlb, sender))
                { VisualStateManager.GoToState(hlb, "ActiveLink", true); }
                else
                { VisualStateManager.GoToState(hlb, "InactiveLink", true); }
            }
        }

	}
}