﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using FDOT.GIS.Client.Commands;
using FDOT.GIS.Client.Domain;
using FDOT.GIS.Client.Domain.Gis;
using FDOT.GIS.Client.Domain.Graphics;
using FDOT.GIS.Client.Domain.Routing;

namespace FDOT.GIS.Client.Components.Views.Routing
{
    public partial class DrivingDirectionsView : UserControl
    {
        private GraphicsManager graphicsManager;

        public DrivingDirectionsView()
        {
            InitializeComponent();

            graphicsManager = GraphicManagerFactory.CreateGraphicsManager();
        }

        private void OnDirectionClicked(object sender, RoutedEventArgs e)
        {
            var direction = (DrivingDirection)((Button) sender).DataContext;

            var zoomCommand = new ZoomToGeometry(direction.Geometry, 1.3);
            zoomCommand.Execute(null);            
        }

        private void OnMouseEnter(object sender, MouseEventArgs e)
        {
            var direction = (DrivingDirection)((Button)sender).DataContext;
            graphicsManager.AddGraphic(direction.Geometry, SymbolDefinition.AnimatedRedLineSymbol, null, null);
            ((Button)sender).Background = new SolidColorBrush(Colors.Orange);
        }

        private void OnMouseLeave(object sender, MouseEventArgs e)
        {            
            graphicsManager.ClearGraphics();
            ((Button)sender).Background = new SolidColorBrush(Colors.Transparent);
        }

        
    }
}
